/*  Richard G Brown */
/*  Plug-in nodes for MQSeries Integrator version 2 */

#ifndef __RGB_NODE
#define __RGB_NODE

/* //////////////////////////////////////////////////////////////////// */
/*  helper utilities (cross platform strings, etc) */

#include "rgbnodeutils.h"
#include "compression.h"

#define RGB_NUMBER_OF_DEFAULT_ATTRIBUTES 5

/* //////////////////////////////////////////////////////////////////// */
/*  Mandatory Nodal Functions */

/*  CreateNodeContext */

void* CompDecompCreateNodeContext(
				  CciFactory* factoryObject,
				  CciChar*    nodeName,
				  CciNode*    nodeObject);
/*  DeleteNodeContext */

void CompDecompDeleteNodeContext(CciContext* nodeContext);

int CompDecompGetAttributeName(
			       CciContext* context,
			       int         index,
			       CciChar*    buffer,
			       int         bufsize);

/*  GetAttribute */

int CompDecompGetAttribute(
			   CciContext* context,
			   CciChar*    attrName,
			   CciChar*    buffer,
			   int         bufsize);

/*  SetAttribute */

int CompDecompSetAttribute(
			   CciContext* context,
			   CciChar*    attrName,
			   CciChar*    attrValue);

/*  CompressorEvaluate */

void CompressorEvaluate(
			CciContext* context,
			CciMessage* pDestinationList,
			CciMessage* pExceptionList,
			CciMessage* pMessage);

/*  DecompressorEvaluate */

void DecompressorEvaluate(
			  CciContext* context,
			  CciMessage* pDestinationList,
			  CciMessage* pExceptionList,
			  CciMessage* pMessage);

/* //////////////////////////////////////////////////////////////////// */
/*  Mandatory Factory Function */

/*  bipGetMessageflowNodeFactory */

void LilFactoryExportPrefix * LilFactoryExportSuffix 
bipGetMessageflowNodeFactory();

#endif





